﻿Imports System.Configuration
Imports MyERP2.DBContext
Imports MyERP2.DAL

Namespace Persistence
    Public Class UnitOfWork
        Implements IUnitOfWork
        ReadOnly Property _context As MyERP2Context
        Public Property ArticlesRepo As ArticleRepository Implements IUnitOfWork.Articles
        Public Property UsersRepo As UserRepository Implements IUnitOfWork.Users
        Public Property UsersSettingsGridRepo As UserSettingsGridRepository Implements IUnitOfWork.UsersSettingsGrid
        Public Property AdressRepo As AdressRepository Implements IUnitOfWork.Adress
        Public Property ArticleSalesPriceRepo As ArticleSalesPriceRepository Implements IUnitOfWork.ArticleSalesPrice
        Public Property ContactBaseRepo As ContactBaseRepository Implements IUnitOfWork.ContactBase
        Public Property ClientRepo As ClientRepository Implements IUnitOfWork.Client
        Public Property CurrencyRepo As CurrencyRepository Implements IUnitOfWork.Currency
        Public Property DiscountGroupRepo As DiscountGroupRepository Implements IUnitOfWork.DiscountGroup
        Public Property IncotermRepo As IncotermRepository Implements IUnitOfWork.Incoterm
        Public Property UserGroupRightRepo As UserGroupRightRepository Implements IUnitOfWork.UserGroupRight
        Public Property LanguageRepo As LanguageRepository Implements IUnitOfWork.Language
        Public Property LegalFormRepo As LegalFormRepository Implements IUnitOfWork.LegalForm
        Public Property NumberRangeRepo As NumberRangeRepository Implements IUnitOfWork.NumberRange
        Public Property ObjectDescriptionRepo As ObjectDescriptionRepository Implements IUnitOfWork.ObjectDescription
        Public Property ObjectNoteRepo As ObjectNoteRepository Implements IUnitOfWork.ObjectNote
        Public Property ProspectRepo As ProspectRepository Implements IUnitOfWork.Prospect
        Public Property ProtocolRepo As ProtocolRepository Implements IUnitOfWork.Protocol
        Public Property SupplierRepo As SupplierRepository Implements IUnitOfWork.Supplier
        Public Property TextDescriptionHeaderRepo As TextDescriptionHeaderRepository Implements IUnitOfWork.TextDescriptionHeader
        Public Property TextDescriptionRepo As TextDescriptionRepository Implements IUnitOfWork.TextDescription
        Public Property UserGroupRepo As UserGroupRepository Implements IUnitOfWork.UserGroup
        Public Property UnitRepo As UnitRepository Implements IUnitOfWork.Unit
        Public Property UserSettingsGridColumnRepo As UserSettingsGridColumnRepository Implements IUnitOfWork.UserSettingsGridColumn
        Public Property FilterDefinitionRepo As FilterDefinitionRepository Implements IUnitOfWork.FilterDefinition
        Public Property FilterItemRepo As FilterItemRepository Implements IUnitOfWork.FilterItem

        Sub New(Optional EnableTracking As Boolean = False)
            _context = New MyERP2Context
            _context.Database.EnsureCreated()
            ArticlesRepo = New ArticleRepository(_context)
            ArticleSalesPriceRepo = New ArticleSalesPriceRepository(_context)
            DiscountGroupRepo = New DiscountGroupRepository(_context)
            TextDescriptionRepo = New TextDescriptionRepository(_context)
            TextDescriptionHeaderRepo = New TextDescriptionHeaderRepository(_context)
            UserGroupRightRepo = New UserGroupRightRepository(_context)
            LanguageRepo = New LanguageRepository(_context)
            UserGroupRepo = New UserGroupRepository(_context)
            UserSettingsGridColumnRepo = New UserSettingsGridColumnRepository(_context)
            UsersRepo = New UserRepository(_context, WithTracking:=EnableTracking)
            UsersSettingsGridRepo = New UserSettingsGridRepository(_context)
            UnitRepo = New UnitRepository(_context)
            CurrencyRepo = New CurrencyRepository(_context)
            NumberRangeRepo = New NumberRangeRepository(_context)
            ProtocolRepo = New ProtocolRepository(_context)
            ObjectDescriptionRepo = New ObjectDescriptionRepository(_context)
            ObjectNoteRepo = New ObjectNoteRepository(_context)
            SupplierRepo = New SupplierRepository(_context)
            IncotermRepo = New IncotermRepository(_context)
            ProspectRepo = New ProspectRepository(_context)
            ClientRepo = New ClientRepository(_context)
            AdressRepo = New AdressRepository(_context)
            ContactBaseRepo = New ContactBaseRepository(_context)
            LegalFormRepo = New LegalFormRepository(_context)
            FilterDefinitionRepo = New FilterDefinitionRepository(_context)
            FilterItemRepo = New FilterItemRepository(_context)
        End Sub

        Public Function Complete() As Integer Implements IUnitOfWork.Complete
            _context.SaveChanges()
            Return _context.SaveChanges
        End Function

#Region "IDisposable Support"
        Public Sub Dispose() Implements IDisposable.Dispose
            _context.Dispose()
        End Sub
#End Region
    End Class
End Namespace
