Imports System.Collections.ObjectModel
Imports Model.Interfaces
Imports Model.MyERP2Model
Imports ViewModel.Interfaces

Namespace ViewModel
    Partial Public Class ArticleVM
        Inherits MyViewModelBase
        Implements ILogicalDelete
        Implements ILogicalTimestamp
        Implements IProtocolableVM


        Dim _BaseItem As Article

        Public Sub New()
        End Sub
        Friend Sub New(__BaseItem As Article)
            _BaseItem = __BaseItem
        End Sub

#Region "Mapped"

#Region "Base"
        Public Property Id As Guid
            Get
                Return _BaseItem.Id
            End Get
            Set(value As Guid)
                _BaseItem.Id = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property ArtNr As String
            Get
                Return _BaseItem.ArtNr
            End Get
            Set(value As String)
                _BaseItem.ArtNr = value
                RaisePropertyChanged()
            End Set
        End Property
#End Region

#Region "Status"
        Public Property ArticleType As Integer
            Get
                Return _BaseItem.ArticleType
            End Get
            Set(value As Integer)
                _BaseItem.ArticleType = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property BasicUnitId As Guid
            Get
                Return _BaseItem.BasicUnitId
            End Get
            Set(value As Guid)
                _BaseItem.BasicUnitId = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property IsLocked As Boolean
            Get
                Return _BaseItem.IsLocked
            End Get
            Set(value As Boolean)
                _BaseItem.IsLocked = value
                RaisePropertyChanged()
            End Set
        End Property
#End Region

#Region "Description"
        Public Property Description1 As String
            Get
                Return _BaseItem.Description1
            End Get
            Set(value As String)
                _BaseItem.Description1 = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property Description2 As String
            Get
                Return _BaseItem.Description2
            End Get
            Set(value As String)
                _BaseItem.Description2 = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property Description3 As String
            Get
                Return _BaseItem.Description3
            End Get
            Set(value As String)
                _BaseItem.Description3 = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property Matchcode As String
            Get
                Return _BaseItem.Matchcode
            End Get
            Set(value As String)
                _BaseItem.Matchcode = value
                RaisePropertyChanged()
            End Set
        End Property

#End Region

#Region "Purchase"
        Public Property ProcurementStatus As Integer
            Get
                Return _BaseItem.ProcurementStatus
            End Get
            Set(value As Integer)
                _BaseItem.ProcurementStatus = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property ProcurementTime As Integer
            Get
                Return _BaseItem.ProcurementTime
            End Get
            Set(value As Integer)
                _BaseItem.ProcurementTime = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property SupplierArtNr As String
            Get
                Return _BaseItem.SupplierArtNr
            End Get
            Set(value As String)
                _BaseItem.SupplierArtNr = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property PurchaseLocked As Boolean
            Get
                Return _BaseItem.PurchaseLocked
            End Get
            Set(value As Boolean)
                _BaseItem.PurchaseLocked = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property PurchaseManagement As Integer
            Get
                Return _BaseItem.PurchaseManagement
            End Get
            Set(value As Integer)
                _BaseItem.PurchaseManagement = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property CriticalArticle As Boolean
            Get
                Return _BaseItem.CriticalArticle
            End Get
            Set(value As Boolean)
                _BaseItem.CriticalArticle = value
                RaisePropertyChanged()
            End Set
        End Property
#End Region

#Region "Production"
        Public Property ProductionLocked As Boolean
            Get
                Return _BaseItem.ProductionLocked
            End Get
            Set(value As Boolean)
                _BaseItem.ProductionLocked = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property ProductionType As Integer
            Get
                Return _BaseItem.ProductionType
            End Get
            Set(value As Integer)
                _BaseItem.ProductionType = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property ProductionWastePerc As Decimal
            Get
                Return _BaseItem.ProductionWastePerc
            End Get
            Set(value As Decimal)
                _BaseItem.ProductionWastePerc = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property LotSize As Decimal
            Get
                Return _BaseItem.LotSize
            End Get
            Set(value As Decimal)
                _BaseItem.LotSize = value
                RaisePropertyChanged()
            End Set
        End Property
#End Region

#Region "Sales"
        Public Property SalesStatus As Integer
            Get
                Return _BaseItem.SalesStatus
            End Get
            Set(value As Integer)
                _BaseItem.SalesStatus = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property AllowDiscount As Boolean
            Get
                Return _BaseItem.AllowDiscount
            End Get
            Set(value As Boolean)
                _BaseItem.AllowDiscount = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property DiscountGroupId As Guid?
            Get
                Return _BaseItem.DiscountGroupId
            End Get
            Set(value As Guid?)
                _BaseItem.DiscountGroupId = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property VATGroupId As Guid?
            Get
                Return _BaseItem.VATGroupId
            End Get
            Set(value As Guid?)
                _BaseItem.VATGroupId = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property SalesUnitId As Guid?
            Get
                Return _BaseItem.SalesUnitId
            End Get
            Set(value As Guid?)
                _BaseItem.SalesUnitId = value
                RaisePropertyChanged()
            End Set
        End Property
#End Region

#Region "Calculation"
        Public Property CostFix As Decimal
            Get
                Return _BaseItem.CostFix
            End Get
            Set(value As Decimal)
                _BaseItem.CostFix = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property CostVariable As Decimal
            Get
                Return _BaseItem.CostVariable
            End Get
            Set(value As Decimal)
                _BaseItem.CostVariable = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property SalesPriceCalculation As Integer
            Get
                Return _BaseItem.SalesPriceCalculation
            End Get
            Set(value As Integer)
                _BaseItem.SalesPriceCalculation = value
                RaisePropertyChanged()
            End Set
        End Property
#End Region

#Region "Dimensions"
        Public Property DimWeight As Decimal?
            Get
                Return _BaseItem.DimWeight
            End Get
            Set(value As Decimal?)
                _BaseItem.DimWeight = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property DimWeightUnitId As Guid?
            Get
                Return _BaseItem.DimWeightUnitId
            End Get
            Set(value As Guid?)
                _BaseItem.DimWeightUnitId = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property DimArea As Decimal?
            Get
                Return _BaseItem.DimArea
            End Get
            Set(value As Decimal?)
                _BaseItem.DimArea = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property DimAreaUnitId As Guid?
            Get
                Return _BaseItem.DimAreaUnitId
            End Get
            Set(value As Guid?)
                _BaseItem.DimAreaUnitId = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property DimVolume As Decimal?
            Get
                Return _BaseItem.DimVolume
            End Get
            Set(value As Decimal?)
                _BaseItem.DimVolume = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property DimVolumeUnitId As Guid?
            Get
                Return _BaseItem.DimVolumeUnitId
            End Get
            Set(value As Guid?)
                _BaseItem.DimVolumeUnitId = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property DimLength As Decimal?
            Get
                Return _BaseItem.DimLength
            End Get
            Set(value As Decimal?)
                _BaseItem.DimLength = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property DimWidth As Decimal?
            Get
                Return _BaseItem.DimWidth
            End Get
            Set(value As Decimal?)
                _BaseItem.DimWidth = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property DimHeight As Decimal?
            Get
                Return _BaseItem.DimHeight
            End Get
            Set(value As Decimal?)
                _BaseItem.DimHeight = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property DimDimUnitId As Guid?
            Get
                Return _BaseItem.DimDimUnitId
            End Get
            Set(value As Guid?)
                _BaseItem.DimDimUnitId = value
                RaisePropertyChanged()
            End Set
        End Property
#End Region

#Region "Stock"
        Public Property MinStock As Integer
            Get
                Return _BaseItem.MinStock
            End Get
            Set(value As Integer)
                _BaseItem.MinStock = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property MaxStock As Integer
            Get
                Return _BaseItem.MaxStock
            End Get
            Set(value As Integer)
                _BaseItem.MaxStock = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property MinStockWarning As Boolean
            Get
                Return _BaseItem.MinStockWarning
            End Get
            Set(value As Boolean)
                _BaseItem.MinStockWarning = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property MaxStockWarning As Boolean
            Get
                Return _BaseItem.MaxStockWarning
            End Get
            Set(value As Boolean)
                _BaseItem.MaxStockWarning = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property NoNegativeStock As Boolean
            Get
                Return _BaseItem.NoNegativeStock
            End Get
            Set(value As Boolean)
                _BaseItem.NoNegativeStock = value
                RaisePropertyChanged()
            End Set
        End Property
#End Region

#Region "Export"
        Public Property TaricNo As String
            Get
                Return _BaseItem.TaricNo
            End Get
            Set(value As String)
                _BaseItem.TaricNo = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property OriginCountryCode As String
            Get
                Return _BaseItem.OriginCountryCode
            End Get
            Set(value As String)
                _BaseItem.OriginCountryCode = value
                RaisePropertyChanged()
            End Set
        End Property
#End Region

#End Region

#Region "Navigation Properties"
        Public Overridable Property NvArticleSalesPrices As New ObservableCollection(Of ArticleSalesPriceVM)
        Public Overridable Property NvDescription As New ObservableCollection(Of ObjectDescriptionVM)
        Public Overridable Property NvNotes As New ObservableCollection(Of ObjectNoteVM)
        Public Overridable Property NVArticleDescriptions As New ObservableCollection(Of TextDescriptionHeaderVM)
        Public Overridable Property NvUnitWeight As UnitVM
        Public Overridable Property NvUnitDimension As UnitVM
        Public Overridable Property NvUnitArea As UnitVM
        Public Overridable Property NvUnitVolume As UnitVM
        Public Overridable Property NvUnitBase As UnitVM
        Public Overridable Property NvUnitSales As UnitVM
        Public Overridable Property NVVATGroup As VatGroupVM
        Public Overridable Property NVDiscountGroup As DiscountGroupVM
#End Region

#Region "Interfaces"
        Public Property DeletedFlag As Boolean Implements ILogicalDelete.DeletedFlag
            Get
                Return _BaseItem.DeletedFlag
            End Get
            Set(value As Boolean)
                _BaseItem.DeletedFlag = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property DeletedTimestamp As Date? Implements ILogicalDelete.DeletedTimestamp
            Get
                Return _BaseItem.DeletedTimestamp
            End Get
            Set(value As Date?)
                _BaseItem.DeletedTimestamp = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property LastUpdateTimestamp As Date? Implements ILogicalTimestamp.LastUpdateTimestamp
            Get
                Return _BaseItem.LastUpdateTimestamp
            End Get
            Set(value As Date?)
                _BaseItem.LastUpdateTimestamp = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property CreationTimestamp As Date? Implements ILogicalTimestamp.CreationTimestamp
            Get
                Return _BaseItem.CreationTimestamp
            End Get
            Set(value As Date?)
                _BaseItem.CreationTimestamp = value
                RaisePropertyChanged()
            End Set
        End Property

        Public Property Protocol As ICollection(Of ProtocolVM) Implements IProtocolableVM.Protocol
#End Region


    End Class
End Namespace