Imports System.Collections.ObjectModel
Imports Model.Interfaces
Imports Model.MyERP2Model
Imports ViewModel.Interfaces

Namespace ViewModel
    Partial Public Class SupplierVM
        Inherits MyViewModelBase
        Implements ILogicalDelete
        Implements ILogicalTimestamp
        Implements IProtocolableVM

        Dim _BaseItem As Supplier

        Public Sub New()
        End Sub
        Friend Sub New(__BaseItem As Supplier)
            _BaseItem = __BaseItem
        End Sub

#Region "Mapped"
        Public Property Id As Guid
            Get
                Return _BaseItem.Id
            End Get
            Set(value As Guid)
                _BaseItem.Id = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property IdentNr As String
            Get
                Return _BaseItem.IdentNr
            End Get
            Set(value As String)
                _BaseItem.IdentNr = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property IsPrivate As Boolean
            Get
                Return _BaseItem.IsPrivate
            End Get
            Set(value As Boolean)
                _BaseItem.IsPrivate = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property IsLocked As Boolean
            Get
                Return _BaseItem.IsLocked
            End Get
            Set(value As Boolean)
                _BaseItem.IsLocked = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property Name1 As String
            Get
                Return _BaseItem.Name1
            End Get
            Set(value As String)
                _BaseItem.Name1 = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property Name2 As String
            Get
                Return _BaseItem.Name2
            End Get
            Set(value As String)
                _BaseItem.Name2 = value
                RaisePropertyChanged()
            End Set
        End Property

#Region "Address"
        Public Property Address1 As String
            Get
                Return _BaseItem.Address1
            End Get
            Set(value As String)
                _BaseItem.Address1 = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property Address2 As String
            Get
                Return _BaseItem.Address2
            End Get
            Set(value As String)
                _BaseItem.Address2 = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property ZipCode As String
            Get
                Return _BaseItem.ZipCode
            End Get
            Set(value As String)
                _BaseItem.ZipCode = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property Place As String
            Get
                Return _BaseItem.Place
            End Get
            Set(value As String)
                _BaseItem.Place = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property CountryCode As String
            Get
                Return _BaseItem.CountryCode
            End Get
            Set(value As String)
                _BaseItem.CountryCode = value
                RaisePropertyChanged()
            End Set
        End Property
#End Region

#Region "Contact"
        Public Property PhoneNo As String
            Get
                Return _BaseItem.PhoneNo
            End Get
            Set(value As String)
                _BaseItem.PhoneNo = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property MobileNo As String
            Get
                Return _BaseItem.MobileNo
            End Get
            Set(value As String)
                _BaseItem.MobileNo = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property EMail As String
            Get
                Return _BaseItem.EMail
            End Get
            Set(value As String)
                _BaseItem.EMail = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property PurchaseEMail As String
            Get
                Return _BaseItem.PurchaseEMail
            End Get
            Set(value As String)
                _BaseItem.PurchaseEMail = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property Homepage As String
            Get
                Return _BaseItem.Homepage
            End Get
            Set(value As String)
                _BaseItem.Homepage = value
                RaisePropertyChanged()
            End Set
        End Property
#End Region

#Region "Accouting"
        Public Property PricesInclVat As Boolean
            Get
                Return _BaseItem.PricesInclVat
            End Get
            Set(value As Boolean)
                _BaseItem.PricesInclVat = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property CreditLimit As Decimal
            Get
                Return _BaseItem.CreditLimit
            End Get
            Set(value As Decimal)
                _BaseItem.CreditLimit = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property CreditLimitChangeDate As Date
            Get
                Return _BaseItem.CreditLimitChangeDate
            End Get
            Set(value As Date)
                _BaseItem.CreditLimitChangeDate = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property VatNo As String
            Get
                Return _BaseItem.VatNo
            End Get
            Set(value As String)
                _BaseItem.VatNo = value
                RaisePropertyChanged()
            End Set
        End Property
#End Region

#End Region

#Region "Navigation Properties"

#End Region

#Region "Interfaces"
        Public Property DeletedFlag As Boolean Implements ILogicalDelete.DeletedFlag
            Get
                Return _BaseItem.DeletedFlag
            End Get
            Set(value As Boolean)
                _BaseItem.DeletedFlag = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property DeletedTimestamp As Date? Implements ILogicalDelete.DeletedTimestamp
            Get
                Return _BaseItem.DeletedTimestamp
            End Get
            Set(value As Date?)
                _BaseItem.DeletedTimestamp = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property LastUpdateTimestamp As Date? Implements ILogicalTimestamp.LastUpdateTimestamp
            Get
                Return _BaseItem.LastUpdateTimestamp
            End Get
            Set(value As Date?)
                _BaseItem.LastUpdateTimestamp = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property CreationTimestamp As Date? Implements ILogicalTimestamp.CreationTimestamp
            Get
                Return _BaseItem.CreationTimestamp
            End Get
            Set(value As Date?)
                _BaseItem.CreationTimestamp = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property Protocol As ICollection(Of ProtocolVM) Implements IProtocolableVM.Protocol
#End Region
    End Class

End Namespace
