﻿Imports System.Collections.ObjectModel
Imports Model.Interfaces
Imports Model.MyERP2Model

Namespace ViewModel
    Partial Public Class UserSettingsGridVM
        Inherits MyViewModelBase
        Implements ILogicalDelete
        Implements ILogicalTimestamp

        Dim _BaseItem As UserSettingsGrid

        Public Sub New()
        End Sub
        Friend Sub New(__BaseItem As UserSettingsGrid)
            _BaseItem = __BaseItem
        End Sub


#Region "Properties"
        Public Property Id As Guid
            Get
                Return _BaseItem.Id
            End Get
            Set(value As Guid)
                _BaseItem.Id = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property UserId As Guid
            Get
                Return _BaseItem.UserId
            End Get
            Set(value As Guid)
                _BaseItem.UserId = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property ViewName As String
            Get
                Return _BaseItem.ViewName
            End Get
            Set(value As String)
                _BaseItem.ViewName = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property GridName As String
            Get
                Return _BaseItem.GridName
            End Get
            Set(value As String)
                _BaseItem.GridName = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property IsStandard As Boolean
            Get
                Return _BaseItem.IsStandard
            End Get
            Set(value As Boolean)
                _BaseItem.IsStandard = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property InDashboard As Boolean
            Get
                Return _BaseItem.InDashboard
            End Get
            Set(value As Boolean)
                _BaseItem.InDashboard = value
                RaisePropertyChanged()
            End Set
        End Property
#End Region

#Region "Navigation Properties"
        Public Overridable Property NVUserSettingsGridColumns As New ObservableCollection(Of UserSettingsGridColumnVM)
        Public Overridable Property NvUser As UserVM
#End Region

#Region "Interfaces"
        Public Property DeletedFlag As Boolean Implements ILogicalDelete.DeletedFlag
            Get
                Return _BaseItem.DeletedFlag
            End Get
            Set(value As Boolean)
                _BaseItem.DeletedFlag = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property DeletedTimestamp As Date? Implements ILogicalDelete.DeletedTimestamp
            Get
                Return _BaseItem.DeletedTimestamp
            End Get
            Set(value As Date?)
                _BaseItem.DeletedTimestamp = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property LastUpdateTimestamp As Date? Implements ILogicalTimestamp.LastUpdateTimestamp
            Get
                Return _BaseItem.LastUpdateTimestamp
            End Get
            Set(value As Date?)
                _BaseItem.LastUpdateTimestamp = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property CreationTimestamp As Date? Implements ILogicalTimestamp.CreationTimestamp
            Get
                Return _BaseItem.CreationTimestamp
            End Get
            Set(value As Date?)
                _BaseItem.CreationTimestamp = value
                RaisePropertyChanged()
            End Set
        End Property
#End Region

    End Class
End Namespace
